<script>
  // Imports
  import { scaleLinear, scaleOrdinal } from 'd3-scale';
  import { schemeDark2 } from 'd3-scale-chromatic';
  import { min, max, extent } from 'd3-array';
  import { axisBottom, axisLeft } from "d3-axis";
  import Axis from "./Axis.svelte"

  // Dimensions
  const width = 600;
  const height = 300;
  const margin = { top: 10, right: 10, bottom: 30, left: 60 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

  // Array
  const data = [
    { service: "Netflix", viewers: 2.9 },
    { service: "Amazon Prime Video", viewers: 1.3 },
    { service: "Disney+", viewers: 2.1 },
    { service: "Hulu", viewers: 0.9 },
    { service: "Apple TV", viewers: 1.1 },
    { service: "Rakuten", viewers: 0.4 }
  ];

  var x_values = [1,2,3,4,5,6];
  var y_values = data.map(function(elt) { return elt.viewers; });
  var c_values = data.map(function(elt) { return elt.service; });

  // scales
  let xScale = scaleLinear()
    .domain([0,max(x_values)])
    .range([0, innerWidth]);
  let yScale = scaleLinear()
    .domain([0,max(y_values)])
    .range([innerHeight, 0]);
  let cScale = scaleOrdinal()
    .domain(c_values)
    .range(schemeDark2)

  function xAxis(g){const xAxis = axisBottom(xScale).tickValues(c_values); xAxis(select(g))}


</script>

<!-- setting a viewBox and max-width allows the SVG to shrink but not grow! -->
<svg viewbox="0 0 {width} {height}" style="max-width: {width}px">
  <g transform={`translate(${margin.left},${margin.top})`} use:xAxis>
    <Axis {innerHeight} margin={margin.bottom} scale={cScale} position="bottom2" tValues={c_values}/>
    <Axis {innerHeight} margin=-5 scale={yScale} position="left" nbYTicks=7/>
    {#each data as value, i}
      <rect x="{xScale(i)}" y="{yScale(value.viewers)}" width="{innerWidth/6-10}" height="{innerHeight-yScale(value.viewers)}" fill="{cScale(value.service)}"/>
    {/each}
    <text x={-innerHeight+50} y=-35 transform="rotate(-90)">Number of viewers</text>
  </g>
</svg>




